/*
*******************************************************************************
*  Copyright (c) 1996 Martin Poole                            *
*******************************************************************************
**
** WARNING !!  WARNING !! WARNING !! WARNING !! WARNING !! WARNING !!
**
** Any changes to be made to this file should first be checked with
** mplib1 source control for library integrity.
**
** mplib1 source control can be reached at  mplib1@quatermass.co.uk
** 
*
*  $Source: /home/cvs/cvsroot/onelan/onelan/src/mplib1/libsrc/bpo_l_010.c,v $
*  $Author: mpoole $
*  $Date: 2002/10/07 09:37:36 $
*  $Revision: 1.2 $
*
*******************************************************************************
*
* Change History
*
* $Log: bpo_l_010.c,v $
* Revision 1.2  2002/10/07 09:37:36  mpoole
* Initial checkin of mplib1-3.1.0
*
* Revision 1.1  2002/10/07 09:36:53  mpoole
* Initial checkin of mplib1-3.1.0
*
*
*******************************************************************************
*/

#ident "$Header: /home/cvs/cvsroot/onelan/onelan/src/mplib1/libsrc/bpo_l_010.c,v 1.2 2002/10/07 09:37:36 mpoole Exp $"

/* ------------------------------------------------------------------
    Include files
   ------------------------------------------------------------------ */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <memory.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <sys/ipc.h>
#include <sys/shm.h>

#include <mplib1/mplib1_config.h>
#include <mplib1/bpo_lock.h>
#include <mplib1/bpo_list.h>
#include <include/bpo_list_internal.h>
#include <mplib1/bpo_init.h>
#include <mplib1/stricmp.h>

/* ------------------------------------------------------------------
    defines
   ------------------------------------------------------------------ */

/* ------------------------------------------------------------------
    Code starts here
   ------------------------------------------------------------------ */

void *
bpo_Find_Item_By_Name( bpo_List_t *list, const char *name )
{
    void *item=NULL;
    bpo_Node_t *node;
    void *seg_base;

    seg_base = Get_SODB_Base( list );
    if (seg_base==NULL)
	return(NULL);

    bpo_pid_Lock( &list->lno_Pid_Lock );
    node = GNNODE( &list->lno_Head, list->lno_Head.lno_Succ );
    /* walk the list until we find the matching entry */
    if (list->lno_Flags & LN_IGNORECASE)
    {
	while (node->lno_Succ)
	{
	    if (stricmp(name,GRPTR( node, node->lno_Name))==0)
	    {
		bpo_pid_Unlock( &list->lno_Pid_Lock );
		return( GRPTR( node, node->lno_Item ) );
	    }
	    node = GNNODE( node, node->lno_Succ);
	};
    }else
    {
	while (node->lno_Succ)
	{
	    if (strcmp(name,GRPTR( node, node->lno_Name))==0)
	    {
		bpo_pid_Unlock( &list->lno_Pid_Lock );
		return( GRPTR( node, node->lno_Item ) );
	    }
	    node = GNNODE( node, node->lno_Succ);
	};
    }
    bpo_pid_Unlock( &list->lno_Pid_Lock );

    return(item);
}

/* -- End of File -- */
