/*
*******************************************************************************
*  Copyright (c) 1996 Martin Poole                            *
*******************************************************************************
**
** WARNING !!  WARNING !! WARNING !! WARNING !! WARNING !! WARNING !!
**
** Any changes to be made to this file should first be checked with
** mplib1 source control for library integrity.
**
** mplib1 source control can be reached at  mplib1@quatermass.co.uk
** 
*
*  $Source: /home/cvs/cvsroot/onelan/onelan/src/mplib1/libsrc/dl_l_009.c,v $
*  $Author: mpoole $
*  $Date: 2002/10/07 09:37:38 $
*  $Revision: 1.2 $
*  Purpose        : Double-linked list handling
*
*******************************************************************************
*
* Change History
*
* $Log: dl_l_009.c,v $
* Revision 1.2  2002/10/07 09:37:38  mpoole
* Initial checkin of mplib1-3.1.0
*
* Revision 1.1  2002/10/07 09:36:56  mpoole
* Initial checkin of mplib1-3.1.0
*
*
*******************************************************************************
*/

#ident "$Header: /home/cvs/cvsroot/onelan/onelan/src/mplib1/libsrc/dl_l_009.c,v 1.2 2002/10/07 09:37:38 mpoole Exp $"

/* ------------------------------------------------------------------
    Include files
   ------------------------------------------------------------------ */

#include <stdlib.h>
#include <string.h>
#include <memory.h>

#include <mplib1/mplib1_config.h>

#include <mplib1/dl_list.h>
#include <mplib1/stricmp.h>

/* ------------------------------------------------------------------
    defines
   ------------------------------------------------------------------ */

/* ------------------------------------------------------------------
    Code starts here
   ------------------------------------------------------------------ */

void *
dl_Find_Item_By_Name( dl_List_t *list, const char *name )
{
    void *item=NULL;
    int ic;
    dl_Node_t *node;

    if (name && *name)
    {
	ic = (list->ln_Flags & LN_IGNORECASE);
	node = list->ln_Head.ln_Succ;
	/* walk the list until we find the matching entry */
	while (node->ln_Succ && item == NULL)
	{
	    if (   node->ln_Name
		&& (   (ic && stricmp(name,node->ln_Name)==0)
		    || (!ic && strcmp(name,node->ln_Name)==0)
		   )
	       )
		item = node->ln_Item;
	    node = node->ln_Succ;
	};
    }
	    
    return(item);
}

/* -- End of File -- */
