/*
*******************************************************************************
*  Copyright (c) 1996 Martin Poole                            *
*******************************************************************************
**
** WARNING !!  WARNING !! WARNING !! WARNING !! WARNING !! WARNING !!
**
** Any changes to be made to this file should first be checked with
** mplib1 source control for library integrity.
**
** mplib1 source control can be reached at  mplib1@quatermass.co.uk
** 
*
*  $Source: /home/cvs/cvsroot/onelan/onelan/src/mplib1/libsrc/dl_l_022.c,v $
*  $Author: mpoole $
*  $Date: 2002/10/07 09:37:39 $
*  $Revision: 1.2 $
*  Purpose        : Double-linked list handling
*
*******************************************************************************
*
* Change History
*
* $Log: dl_l_022.c,v $
* Revision 1.2  2002/10/07 09:37:39  mpoole
* Initial checkin of mplib1-3.1.0
*
* Revision 1.1  2002/10/07 09:36:56  mpoole
* Initial checkin of mplib1-3.1.0
*
*
*******************************************************************************
*/

#ident "$Header: /home/cvs/cvsroot/onelan/onelan/src/mplib1/libsrc/dl_l_022.c,v 1.2 2002/10/07 09:37:39 mpoole Exp $"

/* ------------------------------------------------------------------
    Include files
   ------------------------------------------------------------------ */

#include <stdlib.h>
#include <string.h>
#include <memory.h>

#include <mplib1/mplib1_config.h>

#include <mplib1/dl_list.h>

/* ------------------------------------------------------------------
    defines
   ------------------------------------------------------------------ */

/* ------------------------------------------------------------------
    Code starts here
   ------------------------------------------------------------------ */

void *
dl_Find_Next_Item( dl_Node_t *nptr )
{
    return (nptr != NULL
	    && nptr->ln_Succ != NULL
	    && nptr->ln_Succ->ln_Succ != NULL )
	? nptr->ln_Succ->ln_Item
	: NULL;
}

void *
dl_Find_Prev_Item( dl_Node_t *nptr )
{
    return (nptr != NULL
	    && nptr->ln_Pred != NULL
	    && nptr->ln_Pred->ln_Pred != NULL )
	? nptr->ln_Pred->ln_Item
	: NULL;
}

void *
dl_Find_First_Item( dl_List_t *lptr )
{
    return (lptr!=NULL)
	    ? dl_Find_Next_Item( &lptr->ln_Head )
	    : NULL;
}

void *
dl_Find_Last_Item( dl_List_t *lptr )
{
    return (lptr!=NULL)
	    ? dl_Find_Prev_Item( &lptr->ln_Tail )
	    : NULL;
}

/* -- End of File -- */
