/*
*******************************************************************************
*  Copyright (c) 1997 Martin Poole                            *
*******************************************************************************
**
** WARNING !!  WARNING !! WARNING !! WARNING !! WARNING !! WARNING !!
**
** Any changes to be made to this file should first be checked with
** mplib1 source control for library integrity.
**
** mplib1 source control can be reached at  mplib1@quatermass.co.uk
** 
*
*  $Source: /home/cvs/cvsroot/onelan/onelan/src/mplib1/test/dl_sort_test.c,v $
*  $Author: mpoole $
*  $Date: 2002/10/07 09:37:28 $
*  $Revision: 1.2 $
*
*******************************************************************************
*
* Change History
*
* $Log: dl_sort_test.c,v $
* Revision 1.2  2002/10/07 09:37:28  mpoole
* Initial checkin of mplib1-3.1.0
*
* Revision 1.1  2002/10/07 09:37:06  mpoole
* Initial checkin of mplib1-3.1.0
*
*
*******************************************************************************
*/

#ident "$Header: /home/cvs/cvsroot/onelan/onelan/src/mplib1/test/dl_sort_test.c,v 1.2 2002/10/07 09:37:28 mpoole Exp $"

/* ------------------------------------------------------------------
    Include files
   ------------------------------------------------------------------ */

#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <sys/types.h>
#include <mplib1/mplib1_config.h>
#include <mplib1/dl_list.h>
#include <mplib1/fprintfile.h>

/* ------------------------------------------------------------------
    defines
   ------------------------------------------------------------------ */

struct s_t
{
dl_Node_t	t_node;
int		val;
};

/* ------------------------------------------------------------------
    Code starts here
   ------------------------------------------------------------------ */

static void
p_func( struct s_t *stp )
{
    fprintf(stderr, "Item:%p  Val: %d\n", stp, stp->val );
    return;
}

static int
add_num( dl_List_t *lp, int num )
{
    dl_Node_t *np;
    struct s_t *stp;

    stp = (struct s_t *)malloc( sizeof(struct s_t)  );
    np = &stp->t_node;
    dl_Init_Node( np, NULL, stp );
    stp->val = num;
    p_func( stp );
    dl_Add_Tail( lp, np );
    return(0);
}

static int
i_comp( struct s_t *n1, struct s_t *n2 )
{
    int i1, i2;
    i1 = n1->val;
    i2 = n2->val;
    if (i1 > i2)
	return(1);
    else if (i1 < i2)
	return(-1);
    return(0);
}

static int
l_dump( dl_List_t *lp )
{
    dl_Node_t *np;
    fprintf(stderr,"List: Header:%p  Tail %p\n", &lp->ln_Head, &lp->ln_Tail );
    np = &lp->ln_Head;
    while(np)
    {
	fprintf( stderr, "Node: %p  ln_Succ: %p  ln_Pred: %p  ln_Item: %p\n",
		np, np->ln_Succ, np->ln_Pred, np->ln_Item );
	np = np->ln_Succ;
    };
    return(0);
}

static void
usage( const char *reason )
{
    if (reason)
	fprintf(stderr,"%s\n", reason );
    fprintf(stderr,"Usage: dl_sort_test  seed  count\n\n" );
    exit(1);
    return;
}

int
main( int argc, char *argv[] )
{
    dl_List_t my_list;
    int num;

    dl_Init_List( &my_list, 0 );

    if (argc!=3)
    {
	usage("Insufficient arguments\n");
    }

    srand( (unsigned int)atoi(argv[1]) );
    num = atoi( argv[2] );

    if (num<=1)
    {
	usage("number of elements must be grater than 1");
    }

    fprintfile(stderr,"Generating list\n");
    while(num--)
	add_num( &my_list, rand() );

    fprintfile(stderr,"Sorting list\n");
    dl_sort_i( &my_list, (dl_sort_i_t)i_comp );

    fprintfile(stderr,"Printing list\n");
    dl_Walk_List( &my_list, (dl_Walk_List_t)p_func, NULL );

    fprintfile(stderr,"Dumping list\n");
    l_dump( &my_list );

    return(0);
}

/* -- End of File -- */
